# super 1 at 75% HP : Terra Slam - charges up a powerful Terra Slam onto target area, dealing
#                     damage and launching opponents upwards.
#
# Super 2 at 50% HP : Overgrowth - Roots all nearby opponents in place for 5s.
# 
# Attack1 : Ancient Crush - Summons giant rocks from the ground and launch it towards the target.
# Attack2 : Guardian Charge - Charges towards the target, skewering all opponents in the way. Upon arrival, damages and launches the targets upwards.
# Attack3 : Head Slam - Slams the head onto the ground, causing aoe damage.
# Attack4 : Guardian Leap - Leaps towards target, sending a shockwave upon landing that deals aoe damage and [Slow]

#hp
execute if score worldScore wtc_4 matches 3.. as @e[tag=mervux_hitbox,type=#mervux_hitboxes] run function ampsurv:boss/mervux/system/hurtbox/operation
#execute store result score mervux boss.storage.mervux run data get entity @e[tag=mervux_entity,limit=1,sort=nearest,type=slime] Health

#display bar
execute if score worldScore wtc_4 matches 3.. store result bossbar minecraft:bosshp17 value run scoreboard players get mervux boss.storage.mervux

#hitboxes
function ampsurv:boss/mervux/system/hurtbox/tp
#tp model to entity
execute as @e[tag=mervux_entity,tag=!dying,type=ravager,tag=!leaping] at @s run tp @e[tag=aj.mervux.root,limit=1,sort=nearest] ~ ~ ~ ~ ~
execute as @e[tag=mervux_entity,tag=!dying,type=ravager,tag=leaping] at @s run tp @e[tag=aj.mervux.root,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=mervux_entity,type=ravager] at @s run scoreboard players set @s generic.base.res 2

# score add and score resets
scoreboard players add mervux boss.battle_tick 1
execute if entity @e[tag=mervux_entity,type=ravager,distance=..100] if entity @s[tag=!dying] if score mervux boss.battle_tick matches 500.. run scoreboard players set mervux boss.battle_tick 1
execute if score mervux boss.battle_tick matches 250 run tag @e remove mervux_target
execute if score mervux boss.battle_tick matches 499 run tag @e remove mervux_target

#particle
particle dust 0 1 0 1 ~ ~1 ~ 1 1 1 0 5 normal
execute as @e[tag=aj.mervux.bone,type=armor_stand] at @s run particle spore_blossom_air ~ ~1.5 ~ 0.5 0.5 0.5 1 2 normal
particle dust 0.412 0.318 0.055 1 ~ ~ ~ 1 0 1 0 3 normal

#hurt
execute if entity @e[tag=mervux_hitbox,tag=hurt,type=#mervux_hitboxes] run playsound minecraft:entity.donkey.hurt ambient @a[distance=..40] ~ ~ ~ 1 0 0

# boss.storage2 animation cooldown
execute if score mervux boss.storage2 matches 1.. run scoreboard players remove mervux boss.storage2 1
# boss.storage1 attack cooldown
execute if score mervux boss.storage1 matches 1.. run scoreboard players remove mervux boss.storage1 1

#music
execute if score mervux boss.mervux.music matches 1.. run scoreboard players remove mervux boss.mervux.music 1
execute if score mervux boss.mervux.music matches 0 run playsound minecraft:boss.worldboss.theme record @a[distance=..100] ~ ~ ~ 0.7 1 0.7
execute if score mervux boss.mervux.music matches 0 run scoreboard players set mervux boss.mervux.music 3120

#targetting system
execute as @e[tag=mervux_entity,type=ravager] at @s if score worldScore wtc_10 matches 9.. run function ampsurv:boss/mervux/system/targetting

# attack randomizer
execute if score worldScore wtc_4 matches 3.. if score mervux ally.anim_tick matches ..5 run scoreboard players add mervux ally.anim_tick 1
execute if score worldScore wtc_10 matches 9.. if score mervux ally.anim_tick matches 5.. run scoreboard players set mervux ally.anim_tick 0

#idle animation in battle
execute if score mervux boss.battle_tick matches 1.. if score mervux boss.storage2 matches ..0 if entity @e[tag=aj.mervux.root,tag=!attack,tag=!dying] if entity @e[tag=mervux_entity,nbt={Motion:[0d,0d,0d]},tag=!leaping] run execute as @e[tag=aj.mervux.root,type=marker] at @s run function mervux:animations/idle/next_frame
execute if score mervux boss.battle_tick matches 1.. if score mervux boss.storage2 matches ..0 if entity @e[tag=aj.mervux.root,tag=!attack,tag=!dying] if entity @e[tag=mervux_entity,nbt=!{Motion:[0d,0d,0d]},tag=!leaping] run execute as @e[tag=aj.mervux.root,type=marker] at @s run function mervux:animations/walk/next_frame

#choose attack
execute if score mervux boss.battle_tick matches 1.. if score mervux boss.storage2 matches ..0 if score mervux boss.storage1 matches ..0 if entity @e[tag=aj.mervux.root,tag=!attack,tag=!dying,tag=!ovr_next,tag=!trr_next] run execute as @e[tag=aj.mervux.root,type=marker] at @s run function ampsurv:boss/mervux/system/phases/attackphases/manager

#loops
function ampsurv:boss/mervux/attacks/projectile/manager
function ampsurv:boss/mervux/attacks/hitbox/manager
execute as @e[tag=mervux_entity,limit=1,sort=nearest,tag=leaping] at @s run function ampsurv:boss/mervux/attacks/leap/leaploop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.headslam] run function ampsurv:boss/mervux/attacks/headslam/loop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.ancient_crush] run function ampsurv:boss/mervux/attacks/ancient_crush/loop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.leap] as @s at @s run function ampsurv:boss/mervux/attacks/leap/loop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.terraspike] as @s at @s run function ampsurv:boss/mervux/attacks/terraspike/loop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.overgrowth] as @s at @s run function ampsurv:boss/mervux/attacks/overgrowth/loop
execute if entity @s[tag=!dying,tag=aj.mervux.anim.tobattle] as @s at @s run function ampsurv:boss/mervux/attacks/projectile/loop-tobattle
execute if entity @s[tag=!dying,tag=trr_next] run function ampsurv:boss/mervux/attacks/terraspike/wait
execute if entity @s[tag=!dying,tag=ovr_next] run function ampsurv:boss/mervux/attacks/overgrowth/wait

#percent detections
#75%
execute as @e[tag=aj.mervux.root,type=marker,tag=!75_percent] if score mervux boss.storage.mervux matches ..300 run function ampsurv:boss/mervux/system/phases/detect/75
#50%
execute as @e[tag=aj.mervux.root,type=marker,tag=!50_percent] if score mervux boss.storage.mervux matches ..200 run function ampsurv:boss/mervux/system/phases/detect/50

#death ------------------------------------
# check
execute as @e[tag=aj.mervux.root,type=marker,tag=!dying,tag=scened] if score mervux boss.storage.mervux matches ..1 run function ampsurv:boss/mervux/system/defeat-trig
# loop
execute as @e[tag=aj.mervux.root,type=marker,tag=dying,tag=scened] at @s run function ampsurv:boss/mervux/system/defeat

#retreat
execute unless entity @e[tag=mervux_battle_center,distance=..50] run tag @s add retreating
execute unless entity @a[tag=!dead,distance=..50] run tag @s add retreating
#loop
execute as @e[tag=aj.mervux.root,type=marker,tag=retreating,tag=scened] run function ampsurv:boss/mervux/system/retreat